<?php
/*
Plugin Name: Grabber Widget
Plugin URI: http://www.acumendevelopment.net
Description: Grabs arbitrary HTML elements from other pages for use on your template
Author: Leo Brown
Version: 0.2
Author URI: http://www.acumendevelopment.net
*/

Class Grabber{

	function grab($url,$element,$type){

		$content=file_get_contents($url);

		// default is to provide URL content
		if(!$type) return $content;

		$doc = new DOMDocument();
		@$doc->loadHTML($content);

		// get the XML element - see http://php.net/manual/en/domxpath.query.php
		$xpath = new DOMXPath($doc);
		if($type=='xpath'){
			$result = $xpath->query($element);
		}
		elseif($type=='id'){
			$result = $xpath->query("//*[@id='{$element}']");
		}
		else{
			return 'Unknown extraction type.';
		}

		// re-extract the HTML
		$newDom = new DOMDocument;
		if($result->item(0)){
			$newDom->appendChild($newDom->importNode($result->item(0),1));
			return $newDom->saveHTML();
		}
		else{
			return 'Could not load content';
		}

	}
}

// shortcode setup
function grabber_shortcode($atts) {
	extract(shortcode_atts(array(
		'url' => '',
		'type' => '',
		'element' => ''
	), $atts));

	$grabber=new Grabber();
	return $grabber->grab($url,$element,$type);
}
add_shortcode('grabber', 'grabber_shortcode');

Class Grabber_Widget extends WP_Widget{

	var $grabber;

	function Grabber_Widget(){
		$this->grabber=new Grabber();
		$widget_ops = array( 'classname' => 'grabber', 'description' => 'Grabs abitrary HTML from other pages/sites');
		$control_ops = array( 'width' => 200, 'height' => 350, 'id_base' => 'grabber-widget' );
		$this->WP_Widget( 'grabber-widget', 'Grabber Widget', $widget_ops, $control_ops );
	}

	function widget( $args, $instance ) {

		extract( $args );
		$title = apply_filters('widget_title', $instance['title'] );

		echo $before_widget;
		if($title) echo $before_title . $title . $after_title;

		// widget display
		if($url=$instance['url']){
			echo $this->grabber->grab($instance['url'],$instance['element'], $instance['type']);
		}
		echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['url'] = strip_tags( $new_instance['url'] );
		$instance['element'] = strip_tags( $new_instance['element'] );
		$instance['type'] = strip_tags( $new_instance['type'] );
		return $instance;
	}

	function form($instance){?>
		<p>
			<label for="<?php echo $this->get_field_id('url'); ?>">URL</label>
			<input id="<?php echo $this->get_field_id('url'); ?>"
				name="<?php echo $this->get_field_name('url'); ?>"
				value="<?php echo $instance['url']; ?>"
				style="width:90%;"
			/>
			<label for="<?php echo $this->get_field_id('element'); ?>">Element Selector</label>
			<input id="<?php echo $this->get_field_id('element'); ?>"
				name="<?php echo $this->get_field_name('element'); ?>"
				value="<?php echo $instance['element']; ?>"
				style="width:90%;"
			/>
			<label for="<?php echo $this->get_field_id('type'); ?>">Selector Type</label>
			<select id="<?php echo $this->get_field_id('type'); ?>"
				name="<?php echo $this->get_field_name('type'); ?>"
				style="width:90%;">
				<option <?php echo ($instance['type']=='id')   ?'SELECTED':'';?> value="id">DOM ID</option>
				<option <?php echo ($instance['type']=='xpath')?'SELECTED':'';?> value="xpath">XPath</option>
			</select>
		</p>	
	<?php }
}

// get WP to load our widget
function init_grabber(){
	register_widget('Grabber_Widget');
}
add_action("widgets_init", "init_grabber");
 
?>
